
import java.lang.*;
import java.util.*;
import javax.microedition.lcdui.*;

public class Graph extends Canvas
{
public int numGr=0;
public int[][] grarr;
public Vector lines;
public int xxSize=50;
public boolean drawme=false;
int[] colors= {0x0000ff, 0x00ff00, 0xff0000, 0x00ffff, 0xff00ff, 0xffff00, 0x000088, 0x008800, 0x880000, 0x888888};
public String[] text=new String[10]; /* stack of strings for output */
Font ff;
int txt=0; /* string stack pointer */
int dy=0; /* font y size */
public int key=0;

public Graph() { super();
		 for(int i=0;i<10;i++) text[i]=""; 
		 lines=new Vector();}

public void paint(Graphics g) {
    ff=g.getFont();
    dy=ff.getHeight();
    int i; int j;
    int w=getWidth();
    int h=getHeight();
    g.setColor(0xffffff);
    g.fillRect(0,0,w,h);
    for(i=0;i<numGr; i++) {
	g.setColor(colors[i]);
	for(j=0;j<xxSize-1; j++) {
	    g.drawLine(j,h-1-grarr[i][j],j+1,h-1-grarr[i][j+1]);
//	    g.drawLine((j*w)/xxSize,h-1-(grarr[i][j]*h)/201,((j+1)*w)/xxSize,h-1-(grarr[i][j+1]*h)/201);
	}
    }
//    g.setColor(0x000000);
    for(i=0;i<lines.size();i++) {
	((Line)lines.elementAt(i)).draw(g);
    }
    lines.removeAllElements();
    g.setColor(0x000000);
    for(i=0;i<10;i++) {
	if(text[i].length()>0) g.drawString(text[i],5,5+i*dy,Graphics.TOP|Graphics.LEFT);
	text[i]=""; }
    txt=0;
    drawme=false;

}

public void addstr(String s) {
    text[txt]=s;
    txt++;
    if(txt>=10) txt=0;
}

protected void keyPressed(int keycode) {
    key=keycode;    
}
protected void keyRepeated(int keycode) {
    key=keycode;    
}


}