
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import ral.*;

public class fvmMidp extends fvm implements Runnable {
    private StringItem t_t_out;
    private TextField t_t_in;
    private Graph t_gr;
    private Display disp;
    private List t_m;
    private int col;
    public fvmMidp(StringItem txt_out, TextField txt_in, Graph gr_gr, List m_m, Display disp1) {
	t_t_out=txt_out;
	t_t_in=txt_in;
	t_gr=gr_gr;
	t_m=m_m;
	disp=disp1;
	xSize=t_gr.getWidth();
	ySize=t_gr.getHeight();
	initvoc();
//	graphs = new Real[10][xSize+1];
//	gr = new int[10][xSize+1];

    }
    public void output(String s) {
	if(in_graph) t_gr.addstr(s);
	else t_t_out.setText(t_t_out.getText()+s);   // !!! scroll up
//	disp.setCurrent(t_t_out);
    }
    public void abort(String s) {
    t_t_out.setText(t_t_out.getText()+s);
    }
    
    public void plot() {
	t_gr.numGr=numberOfGraphs;
	t_gr.xxSize=xSize;
	t_gr.grarr=gr;
	t_gr.drawme=true;
	t_gr.repaint();
//	disp.setCurrent(t_gr);
    }
    public void preplot() { disp.setCurrent(t_gr); }
    

    public void run() { 
	try {interpret();} 
	catch(Exception e) { 
	    if(!quit) {
		Alert al = new Alert("!", diagnose() +" Going reset.",null,null);
		disp.setCurrent(al);
		clear();
		try {Thread.sleep(3000);} catch(Exception ee) {}
		disp.setCurrent(t_m);
	    }
	}
	t_t_out.setText(t_t_out.getText()+"\n"); 
	}
	
    public void setout(String s) {
	t_t_out.setText(s);
    }
    public void setinput(String s) {
	t_t_in.setChars(s.toCharArray(),0,s.length());
    }
    public void cli() {setinput("");}
    public void clo() {setout("");}

    
    public void sleeep(long t) {
	try {Thread.sleep(t);} catch(Exception e) {} }
    
    public void gr_print(String s) {
	t_gr.addstr(s); }
	
    public void line(int x,int y,int type) {
	int x0,y0;
	if(t_gr.lines.size()==0) {
	    x0=0;
	    y0=0;
	} else { 
	    x0=((Line)(t_gr.lines.lastElement())).x2;
	    y0=((Line)(t_gr.lines.lastElement())).y2;
	}
	if(type==2) { t_gr.lines.addElement(new Line(x0,y0,x+x0-1,y+y0-1,col,type));
	    } else {
	t_gr.lines.addElement(new Line(x0,y0,x,y,col,type)); }
    }
    public void pixel(int x, int y) {
	t_gr.lines.addElement(new Line(x,y,x,y,col,2));
    }
    public void setColor(int color) {	col=color;    }
    
    public int getKey() {
	int tmpkey=t_gr.key;
	t_gr.key=0;
	return(tmpkey);
    }
    
    public void bye() {
	clear();
	setout("");
	setinput("");
	disp.setCurrent(t_m);
    }
} /* end class */