/*
 */

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import javax.microedition.rms.*;
import java.io.*;
import java.util.*;

public class frt_sci extends MIDlet implements CommandListener {
    
    private Command exitCommand = new Command("Exit", Command.EXIT, 2); 
    private Command okCommand = new Command("Ok",Command.SCREEN, 2);
    private Command backCommand = new Command("Back",Command.SCREEN,2);
    private Command clearCommand = new Command("Clear Out",Command.SCREEN,2);
    private Command clearInCommand = new Command("Clear In",Command.SCREEN,2);
    private Command selCommand = new Command("Select",Command.ITEM, 1);
    private Command helpCommand = new Command("Help",Command.SCREEN,2);
    private Command sourceCommand = new Command("Source",Command.SCREEN,2);
    private Command menuCommand = new Command("Menu",Command.SCREEN,2);
    // file browser:
    private Command fbopen = new Command("File",Command.SCREEN,2);
    private Command fbview = new Command("View", Command.ITEM, 1);
    private Command fbback = new Command("Back", Command.BACK, 2);
    private Command fbexit = new Command("Exit", Command.EXIT, 3);  
    private final static String UP_DIRECTORY = "..";
    private final static String MEGA_ROOT = "/";
    private final static String SEP_STR = "/";
    private final static char   SEP = '/';

    private Display display;    // The display for this MIDlet
    public List menu;
    private Vector menuFile;
    public Form t_in;
    public StringItem otf;
    public TextField itf;
    public Form helpForm;
    public StringItem helpText;
    public Graph frtGraph = new Graph();
    private String currDirName;
    private String source_text;
    public fvmMidp f;
    public frt_sci() {
        display = Display.getDisplay(this);
    }
    /* saving */
    private Command okSave = new Command("Ok",Command.SCREEN, 2);
    private Command okLoad = new Command("Ok",Command.SCREEN, 2);
    private Thread f_thr;
    
    public void startApp() {

//	itf=new TextField("",)        
	t_in=new Form("Frt-sci");
	t_in.addCommand(okCommand);
	t_in.addCommand(clearInCommand);
	t_in.addCommand(clearCommand);
	t_in.addCommand(helpCommand);
	t_in.addCommand(sourceCommand);
        t_in.addCommand(exitCommand);
	t_in.addCommand(menuCommand);	
	otf=new StringItem("","",StringItem.PLAIN);
	t_in.append(otf);  // !!! scroll-up
	itf=new TextField("","",1024,TextField.ANY);
	t_in.append(itf);
//	t_in.append(otf); // !!! scroll-down
	t_in.setCommandListener(this);
	
	frtGraph.addCommand(backCommand);
	frtGraph.setCommandListener(this);

	menu=new List("Programs",List.IMPLICIT);
	menu.setSelectCommand(selCommand);
	menu.addCommand(exitCommand);
	menu.append("From file",null);
//	menu.addCommand(fbopen);
	menuFile=new Vector();
	narezka(getText("/menu.txt"),menu,menuFile);
	menu.setCommandListener(this);
	display.setCurrent(menu);
	
	f = new fvmMidp(otf,itf, frtGraph,menu,display);	
	
	helpForm=new Form("Help");
	helpText=new StringItem("","",StringItem.PLAIN);
	helpForm.append(helpText);
	helpForm.addCommand(backCommand);
	helpForm.setCommandListener(this);
	
	// file browser section
	currDirName = MEGA_ROOT;
	
	autostart();
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
    }
    
    public void commandAction(Command c, Displayable s) {
	int err;
        if (c == exitCommand) {
            destroyApp(false);
            notifyDestroyed();
        }
	
	if (c == okCommand) {
	    f.str=itf.getString();
	    f_thr=new Thread(f);
	//    if(err==0) {
	    f_thr.start();
	//	try {f_thr.start();} catch(Exception e) {
    	//	    Alert al = new Alert("!","Runtime error, most probably stack underflow/overflow",null,null);
	//	    Display.getDisplay(this).setCurrent(al);
	//	    f.softreset();
	//	}
	//    }
	//    else f.clear();		
	
	}
	
	if (c == backCommand) {
	    display.setCurrent(t_in);
	}
	
	if (c == clearCommand) {
	    f.setout("");
	}
	if (c == clearInCommand) {
	    f.setinput("");
	}	
	
	if (c == selCommand) {
	  if(menu.getSelectedIndex()!=0) {
	    display.setCurrent(t_in);
	    interp(getText("/lib.txt"),"Error in lib.txt");
	    interp(getText( (String)menuFile.elementAt(menu.getSelectedIndex()-1) ),"Error in code."); 
	    }
	  else {	
	    boolean isAPIAvailable = false;
	    if (System.getProperty(
    	      "microedition.io.file.FileConnection.version") != null)
	    {
              isAPIAvailable = true;
              try 
              {
		    new Thread(new Runnable() {
    	        public void run() {
            	showCurrDir();
    	    }}).start();
        	} 
              catch (SecurityException e) 
              {} 
              catch (Exception e) {}
	      }
	        else
                {
                  StringBuffer splashText = new StringBuffer(
                getAppProperty("MIDlet-Name")).append("\n").append(
                getAppProperty("MIDlet-Vendor")).
                append(isAPIAvailable?"":"\nFileConnection API not available");
                  Alert splashScreen = new Alert(null,splashText.toString(),
                null,AlertType.INFO);
    		  splashScreen.setTimeout(3000);
    	      Display.getDisplay(this).setCurrent(splashScreen);
    	        }
	    }
	}
	
	if (c == helpCommand) {
	    helpText.setText(getText("/help.txt"));
	    display.setCurrent(helpForm);
	}
	if (c == sourceCommand) {
//	    helpText.setText(getText( (String)menuFile.elementAt(menu.getSelectedIndex()-1) ));
	    helpText.setText(source_text);
	    display.setCurrent(helpForm);
	}
	if (c == menuCommand) {
	    f.clear();
//	    try{f.interpret();} catch(Exception e) { }
	    f.setout("");
	    f.setinput("");
	    display.setCurrent(menu);
	}
	
	//file browser commands
	if (c == fbview) 
        {
          List curr = (List)s;
          final String currFile = curr.getString(curr.getSelectedIndex());
          new Thread(new Runnable() 
          {
            public void run() 
            {
              if (currFile.endsWith(SEP_STR) || 
                currFile.equals(UP_DIRECTORY)) 
              {
                traverseDirectory(currFile);
              } else 
              {
                showFile(currFile);
              }
            }
          }).start();
        }
        else if (c == fbback) 
        {
          showCurrDir();
        } 
        else if (c == fbexit) 
        {
          display.setCurrent(menu);
        }
    }
    
    private void autostart() {
    String fi="/autostart.frt";
	DataInputStream dis = new DataInputStream(getClass().getResourceAsStream(fi)); 
	StringBuffer strBuff = new StringBuffer();
        int ch = 0;
        try {
            while ((ch = dis.read()) != -1) {
                strBuff.append((char ) ((ch >= 0xc0 && ch <= 0xFF) ? (ch + 0x350) : ( (ch == 13) ? ' ' : ch ) ));
            }
            dis.close();
        } catch (Exception e) { return; }
    
    display.setCurrent(t_in);
    interp(getText("/lib.txt"),"Error in lib.txt");
    interp(getText(fi),"Error in code."); 
    }
    
    private void interp(String source, String message) {
    source_text=source;
    f.str=source;
    try { f.interpret(); } 
    catch (Exception e) {
	if(!f.quit) {
	    Alert al = new Alert("!",message+f.diagnose(),null,null);
	    f.clear();
	    Display.getDisplay(this).setCurrent(al);
	    }
	}
    }

    private String getText(String path) {
        DataInputStream dis = new DataInputStream(getClass().getResourceAsStream(path));
        StringBuffer strBuff = new StringBuffer();
        int ch = 0;
        try {
            while ((ch = dis.read()) != -1) {
                strBuff.append((char ) ((ch >= 0xc0 && ch <= 0xFF) ? (ch + 0x350) : ( (ch == 13) ? ' ' : ch ) ));
            }
            dis.close();
        } catch (Exception e) {
            System.err.println("ERROR in getText() " + e);
        }
        return strBuff.toString();
    }

    private void narezka(String src, List l, Vector v) {
	int sp=0;
	int spn=1;
//	System.err.println(src);
	while(spn>0) {
	    spn=src.indexOf(" ",sp);
	    if(spn>0) {
	    v.addElement(new String("/"+src.substring(sp,spn)));
//	    System.err.println("/"+src.substring(sp,spn));
	    sp=spn+1;
	    spn=src.indexOf("\n",sp);
	    if(spn<0) spn=src.length();
	    l.append(new String(src.substring(sp,spn)),null); 
//	    System.err.println(src.substring(sp,spn));
	    sp=spn+1;
	    }
	}
	
    
    }

    private String readrms(byte[] bb) {
	String str=new String("");
	try{
	str=(new DataInputStream(new ByteArrayInputStream(bb))).readUTF();} catch(Exception e) {}
	return str;
    }
    private void writerms(RecordStore rs, int rec, String str) {
	ByteArrayOutputStream b=new ByteArrayOutputStream();
	DataOutputStream d=new DataOutputStream(b);
	try {
	d.writeUTF(str);
	try { 
	    rs.setRecord(rec,b.toByteArray(),0,b.size());
	    } catch(Exception e) {
	    rs.addRecord(b.toByteArray(),0,b.size());
	    }
	} catch(Exception e) {}
    }
    
    // file browser methods
  void showCurrDir() 
  {
    Enumeration e;
    FileConnection currDir = null;
    List browser;
    try 
    {
      if (MEGA_ROOT.equals(currDirName)) 
      {
            e = FileSystemRegistry.listRoots();
        browser = new List(currDirName, List.IMPLICIT);
      } 
      else 
      {
        currDir = (FileConnection)Connector.open(
          "file://localhost/" + currDirName);
            e = currDir.list();
        browser = new List(currDirName, List.IMPLICIT);
        browser.append(UP_DIRECTORY,null);
      }
      while (e.hasMoreElements()) 
      {
        String fileName = (String)e.nextElement();
        if (fileName.charAt(fileName.length()-1) == SEP) 
        {
          browser.append(fileName,null);
        } 
        else 
        {
          browser.append(fileName,null);
        }
      }
      browser.setSelectCommand(fbview);
      browser.addCommand(fbexit);
      browser.setCommandListener(this);
      if (currDir != null) 
      {
        currDir.close();
      }
      Display.getDisplay(this).setCurrent(browser);
    } 
    catch (IOException ioe) 
    {}

  }
  
  void traverseDirectory(String fileName) 
  {
    if (currDirName.equals(MEGA_ROOT)) 
    {
      if (fileName.equals(UP_DIRECTORY)) 
      {
        // can not go up from MEGA_ROOT
        return;
      }
      currDirName = fileName;
    } 
    else if (fileName.equals(UP_DIRECTORY)) 
    {
      // Go up one directory
      // TODO use setFileConnection when implemented
      int i = currDirName.lastIndexOf(SEP, currDirName.length()-2);
      if (i != -1) 
      {
        currDirName = currDirName.substring(0, i+1);
      } 
      else 
      {
        currDirName = MEGA_ROOT;
      }
    } 
    else 
    {
      currDirName = currDirName + fileName;
    }
    showCurrDir();
  }
  
  void showFile(String fileName) 
  {
    try 
    {
      FileConnection fc = (FileConnection)
      Connector.open("file://localhost/" + currDirName + fileName);
      if (!fc.exists()) 
      {
        throw new IOException("File does not exists");
      }
      InputStream fis = fc.openInputStream();
      StringBuffer strBuff = new StringBuffer();
        int ch = 0;
        try {
            while ((ch = fis.read()) != -1) {
                strBuff.append((char ) ((ch >= 0xc0 && ch <= 0xFF) ? (ch + 0x350) : ch ));
            }
        } catch (Exception e) {
            System.err.println("ERROR in getText() " + e);
        }
      fis.close();
      fc.close();
      display.setCurrent(t_in);
      interp(getText("/lib.txt"),"Error in lib.txt");
      interp(strBuff.toString(),"Error in code");
    }
    catch (Exception e) {}
  }
    
}
